local _
local frame	= CreateFrame("Frame", nil, UIParent)
local textframe = CreateFrame("Frame", "RareAnnText", UIParent)
textframe:SetSize(200,25)
textframe:SetPoint("LEFT",200,100)
textframe:SetMovable(true)
textframe:EnableMouse(true)
textframe:RegisterForDrag("LeftButton")
textframe:SetScript("OnDragStart", frame.StartMoving)
textframe:SetScript("OnDragStop", frame.StopMovingOrSizing)
textframe:SetUserPlaced(true)
textframe.bg = textframe:CreateTexture(nil, "BACKGROUND")
textframe.bg:SetAllPoints(textframe)
textframe.bg:SetTexture(0,0,0,0.7)
textframe.text = textframe:CreateFontString(nil, "OVERLAY")
textframe.text:SetPoint("TOPLEFT", 10, -10)
textframe.text:SetFont("Fonts\\ARIALN.TTF",13,"OUTLINE")
textframe.text:SetTextColor(1,0.8,0,1)

local mobs = {
	-- npc_id = {message sent, died time, name}
	-- Isle of Thunder (map 928)
	[50358] = {0, 0, 0},
	[69664] = {0, 0, 0},
	[69996] = {0, 0, 0},
	[69997] = {0, 0, 0},
	[69998] = {0, 0, 0},
	[69999] = {0, 0, 0},
	[70000] = {0, 0, 0},
	[70001] = {0, 0, 0},
	[70002] = {0, 0, 0},
	[70003] = {0, 0, 0},
	-- Northen Barrens (map 11)
	[71101] = {0, 0, 0},
	[71252] = {0, 0, 0},
	[71253] = {0, 0, 0},
	[71248] = {0, 0, 0},
	[71103] = {0, 0, 0},
	[71251] = {0, 0, 0},
	[71255] = {0, 0, 0},
	[71254] = {0, 0, 0},
	[71102] = {0, 0, 0},
	[71257] = {0, 0, 0},
	[71256] = {0, 0, 0},
	[71258] = {0, 0, 0},
	-- Timeless Isle (map 951)
	[73158] = {0, 0, 0}, -- Emerald Gander
	[72775] = {0, 0, 0}, -- Bufo
	[72909] = {0, 0, 0}, -- Gu'chi the Swarmbringer
	[73163] = {0, 0, 0}, -- Imperial Python
	[73277] = {0, 0, 0}, -- Leafmender
	[72049] = {0, 0, 0}, -- Cranegnasher
	[72808] = {0, 0, 0}, -- Tsavo'ka <Ghost in the Darkness>
	[73161] = {0, 0, 0}, -- Great Turtle Furyshell
	[72245] = {0, 0, 0}, -- Zesqua
	[72048] = {0, 0, 0}, -- Rattleskew
	[71864] = {0, 0, 0}, -- Spelurk
	[73157] = {0, 0, 0}, -- Rock Moss
	[73170] = {0, 0, 0}, -- Watcher Osu
	[73174] = {0, 0, 0}, -- Archiereus of Flame
	[73281] = {0, 0, 0}, -- Dread Ship Vazuvius
	[71919] = {0, 0, 0}, -- Zhu-Gon the Sour
	[72193] = {0, 0, 0}, -- Karkanos
	[72808] = {0, 0, 0}, -- Tsavo'ka
	[73166] = {0, 0, 0}, -- Monsterous Spineclaw
	[73171] = {0, 0, 0}, -- Champion of the Blackflame
	[73175] = {0, 0, 0}, -- Cinderfall
	[73282] = {0, 0, 0}, -- Garnia
	[72045] = {0, 0, 0}, -- Chelon
	[72245] = {0, 0, 0}, -- Zesqua
	[73160] = {0, 0, 0}, -- Ironfur Steelhorn
	[73167] = {0, 0, 0}, -- Huolon
	[73172] = {0, 0, 0}, -- Flintlord Gairan
	[72769] = {0, 0, 0}, -- Spirit of Jadefire
	[72970] = {0, 0, 0}, -- Golganarr
	[73161] = {0, 0, 0}, -- Great Turtle Furyshell
	[73169] = {0, 0, 0}, -- Jakur of Ordon
	[73173] = {0, 0, 0}, -- Urdur the Cauterizer
	[73279] = {0, 0, 0}, -- Evermaw
	[73704] = {0, 0, 0}, -- Stinkbraid
	--[69384] = {0, 0, 0}, --test crab
}
local message
local message_mob_id
local timer, throttle = 0, 3
local text_timer, text_throttle = 0, 10

local function DeathTimes(self,elapsed)
	text_timer = text_timer + elapsed
	if text_timer >= text_throttle then
		local t = ""
		local c = 0
		for k,v in pairs(mobs) do
			if mobs[k][2] > 0 then
				t = t .. mobs[k][3] .. " : " .. SecondsToTime(GetTime() - mobs[k][2], true) .. "\n"
				c = c + 1
			end
		end
		textframe.text:SetText(t)
		textframe:SetHeight(25 + c*13)
		text_timer = 0
	end
end

local function init()
-- MapAreaID 928 = Isle of Thunder
-- MapAreaID 11 = Northern Barrens
	if (GetCurrentMapAreaID() == 928 or GetCurrentMapAreaID() == 11 or GetCurrentMapAreaID() == 951) then
		frame:RegisterEvent("CHAT_MSG_CHANNEL")
		frame:RegisterEvent("PLAYER_TARGET_CHANGED")
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		textframe:Show()
		textframe:SetScript("OnUpdate", DeathTimes)
	else
		frame:UnregisterEvent("CHAT_MSG_CHANNEL")
		frame:UnregisterEvent("PLAYER_TARGET_CHANGED")
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		textframe:Hide()
		textframe:SetScript("OnUpdate", nil)
		end
end

local function update(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		if mobs[message_mob_id][1] + 10 < GetTime() then
			SendChatMessage(message , "CHANNEL", nil, 1)
		end
        timer = 0
		frame:SetScript("OnUpdate", nil)
    end
end

local function RandomizeTime()
	throttle = math.random()*3
	frame:SetScript("OnUpdate", update)
end

local function events(frame, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _,event_type,_,_,_,_,_,guid,name = select(1, ...)
		if event_type == "UNIT_DIED" then
			local id = tonumber(guid:sub(6, 10), 16)
			if not mobs[id] then return end
			mobs[id][2] = GetTime()
			mobs[id][3] = string.sub(name,1,20)
			message = "npc"..id..": "..name.." (0%)"
			message_mob_id = id
			RandomizeTime()
		end
	elseif event == "PLAYER_TARGET_CHANGED" then
		local guid = UnitGUID("target")
		if guid and mobs[tonumber(guid:sub(6, 10), 16)] and not UnitIsDead("target") then
			local id = tonumber(guid:sub(6, 10), 16)
			local name = UnitName("target")
			local x, y = GetPlayerMapPosition("player")
			local hp = math.floor(UnitHealth("target")*100/UnitHealthMax("target"))
			message = "npc"..id..": "..name.." ("..hp.."%). Coordinates: "..math.floor(x*100)..", "..math.floor(y*100)
			message_mob_id = id
			RandomizeTime()
		end
	elseif event == "CHAT_MSG_CHANNEL" then
		local msg,_,_,_,_,_,_,channel = select(1, ...)
		if channel == 1 and string.sub(msg,1,3) == "npc" then
			local id = tonumber(string.sub(msg,4,8))
			if mobs[id] then mobs[id][1] = GetTime() end
		end
	elseif(event == "PLAYER_ENTERING_WORLD" or event == "ZONE_CHANGED_NEW_AREA") then
		init()
	end
end

frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame:SetScript("OnEvent", events)